c======================================================================c

      subroutine iter_fam( lpr )

c======================================================================c

      implicit real*8 (a-h,o-z)
      include 'dirhb.par'
      logical lpr;

      common /fam_flags/ i_coulomb, i_pairing;

      common /fam/ omega_start, omega_end, delta_omega, omega,
     &             gamma_smear, omega_trans_dens,
     &             i_Hartree_response,
     &             J_multipole, K_multipole,
     &             ISO, fac_iso(2);

      common /fam_iter/ error, tol, iter, iter_max;

      CHARACTER*27 text1;
      CHARACTER*25 text2;
      CHARACTER*21 text3;


      iter_max = 999;
      error    = 1.D+10;
      tol      = 1.D-6;
      text1    = 'ITERATION INTERRUPTED AFTER';
      text2    = 'ITERATION CONVERGED AFTER';
      text3    = ' STEPS, FINAL error =';


      if(lpr) then
      write(6,*) '';
      write(6,*) '****** BEGIN iter_fam() ****************************';
      write(6,*) '';
      endif



      write(6,*) '';
      write(6,'(2a,1f6.3,a)') 'START ITERATION ',
     &                        '---------------------> omega = ', omega ,
     &                        '[MeV/hbar]';



      call fam_broyden( .false. , .true. );

      do iter = 1 , iter_max

          write(6,'(i3,a,1f12.6,2a)') iter, '.Iteration, error = ',
     &                                error,'                    ',
     &                                      '         |';

          do it = 1 , 2
              call fam_drhodkappa( .false. , it );
          enddo
          call fam_ddensdcurr ( .false. );
          call fam_dpotentials( .false. );
          call fam_dh1        ( .false. );
          call fam_ddelta     ( .false. );
          call fam_broyden    ( .false. , .false. );


          if( iter.gt.3 .and. error.lt.tol ) then
              write(6,'(a,i4,a,e13.5)') text2, iter, text3, error;
              write(6,*) '';
              EXIT;
          endif
          if( iter .eq. iter_max ) then
              write(6,'(a,i4,a,e11.5)') text1, iter, text3, error;
              EXIT;
          endif

      enddo



      if(lpr) then
      write(6,*) '';
      write(6,*) '****** END iter_fam() ******************************';
      write(6,*) '';
      endif

      return;
      end;
